
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module DE10_Standard_SMK ( 
	//////////// CLOCK //////////
	input 		          		CLOCK2_50,
	input 		          		CLOCK3_50,
	input 		          		CLOCK4_50,
	input 		          		CLOCK_50,

	//////////// KEY //////////
	input 		     [3:0]		KEY,

	//////////// SW //////////
	input 		     [9:0]		SW,

	//////////// LED //////////
	output		     [9:0]		LEDR,

	//////////// Seg7 //////////
	output		     [6:0]		HEX0,
	output		     [6:0]		HEX1,
	output		     [6:0]		HEX2,
	output		     [6:0]		HEX3,
	output		     [6:0]		HEX4,
	output		     [6:0]		HEX5,

	//////////// GPIO, GPIO connect to SMK - Servo Motor Kit //////////
	input 		          		MR_PM_ALERT,
	inout 		    [23:0]		PMW,
	inout 		          		SOC_PM_I2C_SCL,
	inout 		          		SOC_PM_I2C_SDA,
	output		          		SOC_SYS_PDN_n,
	output		          		SOC_WARN_LED,
	input 		          		SYS_PM_ALERT
);





//=======================================================
//  REG/WIRE declarations
//=======================================================
wire [7:0]  Angle;
wire Pwm_0;
wire RESET_N;

//=======================================================
//  Structural coding
//=======================================================

assign HEX0=7'h7f ;
assign HEX1=7'h7f ;
assign HEX2=7'h7f ;
assign HEX3=7'h7f ;
assign HEX4=7'h7f ;
assign HEX5=7'h7f ;



assign PMW[0]   = Pwm_0;
assign LEDR [0] = (Angle == 8'd180)?1'b1:(Angle == 0)?1'b0:Pwm_0;
assign LEDR [1] = (Angle == 8'd180)?1'b1:(Angle == 0)?1'b0:Pwm_0;
assign LEDR [2] = (Angle == 8'd180)?1'b1:(Angle == 0)?1'b0:Pwm_0;
assign LEDR [3] = (Angle == 8'd180)?1'b1:(Angle == 0)?1'b0:Pwm_0;
assign LEDR [4] = (Angle == 8'd180)?1'b1:(Angle == 0)?1'b0:Pwm_0;
assign LEDR [5] = (Angle == 8'd180)?1'b1:(Angle == 0)?1'b0:Pwm_0;
assign LEDR [6] = (Angle == 8'd180)?1'b1:(Angle == 0)?1'b0:Pwm_0;
assign LEDR [7] = (Angle == 8'd180)?1'b1:(Angle == 0)?1'b0:Pwm_0;

assign RESET_N = SW[2];

UI h0(

  .iClk  ( CLOCK_50),
  .iRst_n( RESET_N),
  .iKey  ( KEY[1:0]),
  .iSW   ( SW[1:0]),
  .oAngle( Angle)

);




`define DUR_CLOCK_NUM (50000000/50)    // clock count in 20 ms
`define DEGREE_MAX    (`DUR_CLOCK_NUM*25/200) // 2.5 ms 125000
`define DEGREE_MIN    (`DUR_CLOCK_NUM*5/200)  // 0.5 ms 25000
wire [31:0] PwmAngle;
assign  PwmAngle = (((`DEGREE_MAX - `DEGREE_MIN)/180)*Angle)+`DEGREE_MIN;


PWM_Geneator p0(

	.clk      ( CLOCK_50),
	.reset_n  ( RESET_N),
	//
	.high_dur ( PwmAngle),
	.total_dur( `DUR_CLOCK_NUM),
	
	//
	.PWM(Pwm_0)
);


endmodule
